#import <objc/Object.h>

@interface Player:Object
{
#define BLANK "                                                   "

    char               *hisName;
    char               *myName;
    char               *myHost;
    char               *hisHost;
    char               *refereeHost;
    char               *icon[10], *iconH[10];
    id                  mySidePaymentToHimChips;
    id                  potPileOfChips;
    id                  hisSidePaymentToMeChips;
    int                 pushvalue, pullvalue, hispushvalue, hispullvalue;
    int                 mySidePaymentToHim, hisSidePaymentToMe;
    int                 myPlayerNumber;
    int                 myChoice, hisChoice;
    int                 myPayoff, myTotalWinnings;
    id                  mySetPaymentButton;
    id                  mySetChoiceButton;
    id                  mySlider;
    id                  myRadioButton;
    id                  hisRadioButton;
    id                  mySidePaymentToHimBox;
    id                  hisSidePaymentToMeBox;
    id                  mySidePaymentToHimLabel;
    id                  hisSidePaymentToMeLabel;
    id                  myPayoffBox;
    id                  myTotalWinningsBox;
    id                  myTotalWinningsChips;
    id                  messageBox;
    id                  coverChips;
    id                  coverSlider;
    id                  coverButton;
    id                  myInfoPanel;
    id                  myInfoForm;
    int                 heHasSetPayment, IHaveSetPayment, heHasSetChoice, IHaveSetChoice;
    int                 BothSidePaymentsSet, BothChoicesMade, inPhase1, alreadyDisplayed;
    int                 demoMode;
    id                  pListener;
    id                  pSpeaker;
}

/* methods that are received from Referee*/
- playGameWith:(char *)opponentName atHost:(char *)hisHost
    myPullCard:(int)mypull
    myPushCard:(int)mypush
    hisPullCard:(int)hispull
    hisPushCard:(int)hispush;
    -playRandomGameWith:(char *)hisName atHost:(char *)hisHost
    myPullCard:(int)mypull
    myPushCard:(int)mypush
    hisPullCard:(int)hispull
    hisPushCard:(int)hispush;
    -nudge;
    -startPhaseTwo;

/*methods that are sent to and received from other Player or Referee*/

    -mySidePaymentIs:(int)sidePayment;
    -myChoiceIs:(int)choice;
    -computePayoffs;
    -reportPlayerInfo:sender;
    -playerReset;

/* methods that are local */

    -initNewGame;
    -setMyCards:(int)myPushValue :(int)myPullValue;
    -setHisCards:(int)myPushValue :(int)myPullValue;
    -(int)payoffMatrix:(int)myChoice :(int)hisChoice;
    -displaySidePayments;
    -displayChoice;
    -displayPayoffs;
    -takeSidePaymentFrom:sender;
    -reportSidepayment:sender;
    -reportChoice:sender;
    -refereeHostIs:(char *)name;
    -playerNumberIs:(int)num;

/* methods to establish communication */

    -(port_t)getPortFor:(char *)appName atHost:(char *)appHost;
    -speakerError:(char *)receiverName in:(char *)methodName error:(int)num;
@end
