#import <objc/Object.h>

@interface PlayerReceiver:Object
{
    id                  pListener;
    id                  pSpeaker;
    id                  myPlayer;
    id                  myPlayerNameBox;
    id                  myRefereeHostBox;
    id                  myNamePanel;
    id                  myWindow;
    id                  nameButtons;
    id                  refereeButtons;
}

    -getMyName:sender;
    -appWillInit:sender;
    -free;
    -remoteComputePayoffs;
    -remoteMySidePaymentIs:(int)sidePayment;
    -remoteMyChoiceIs:(int)choice;
    -remotePlayGameWith:(char *)opponentName atHost:(char *)opponentHost
	myPullCard:(int)mypull
	myPushCard:(int)mypush
	hisPullCard:(int)hispull
	hisPushCard:(int)hispush;
    -remotePlayRandomGameWith:(char *)opponentName atHost:(char *)opponentHost
	myPullCard:(int)mypull
	myPushCard:(int)mypush
	hisPullCard:(int)hispull
	hisPushCard:(int)hispush;
    -remoteStartPhaseTwo;
    -remotePlayerNumberIs:(int)num;
    -remoteGameIsOver;
    -remotePlayerReset;
    -remoteNudge;

/* methods to establish communication */
    -(port_t)getPortFor:(char *)appName atHost:(char *)appHost;
    -speakerError:(char *)receiverName;
@end
