#import <appkit/Listener.h>
@interface RefereeListener : Listener
{}
-(int)remotePlayGameWith : (char *) opponentName
	atHost : (char *) opponentHost
	myPullCard : (int) mypull
	myPushCard : (int) mypush
	hisPullCard : (int) hispull
	hisPushCard : (int) hispush;
-(int)remotePlayRandomGameWith : (char *) opponentName
	atHost : (char *) opponentHost
	myPullCard : (int) mypull
	myPushCard : (int) mypush
	hisPullCard : (int) hispull
	hisPushCard : (int) hispush;
-(int)remoteReportGameInfoFrom : (int) num
	side1 : (int) s1
	side2 : (int) s2
	push1 : (int) ps1
	pull1 : (int) pl1
	push2 : (int) ps2
	pull2 : (int) pl2
	choice1 : (int) ch1
	choice2 : (int) ch2
	payoff : (int) pay;
-(int)remoteComputePayoffs;
-(int)remoteCheckInPlayer : (char *) name
	atHost : (char *) host;
-(int)remoteMySidePaymentIs : (int) sidePayment;
-(int)remoteMyChoiceIs : (int) choice;
-(int)remotePlayerNumberIs : (int) num;
-(int)remoteReportChoiceBy : (int) playerNum
	cardPlayed : (int) hisChoice;
-(int)remoteReportPaymentBy : (int) playerNum
	amount : (int) sidePayment;
-(int)remoteStartPhaseTwo;
-(int)remoteReportPlayerInfo : (int) num
	Name : (char *) str1
	Phone : (char *) str2
	SS : (char *) str3;
-(int)remoteGameIsOver;
-(int)remotePlayerReset;
-(int)remoteNudge;
@end