(*^

::[paletteColors = 128; automaticGrouping; currentKernel; 
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e8,  24, "Times"; ;
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e6,  18, "Times"; ;
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, L1, e6,  14, "Times"; ;
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, L1, a20,  18, "Times"; ;
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, L1, a15,  14, "Times"; ;
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, L1, a12,  12, "Times"; ;
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  10, "Times"; ;
	fontset = input, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold, L1,  12, "Courier"; ;
	fontset = output, output, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; ;
	fontset = message, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = print, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = info, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakBelow, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287, L1,  12, "Courier"; ;
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic, L1,  10, "Times"; ;
	fontset = header, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = Left Header, nohscroll, cellOutline,  12, "Palatino"; ;
	fontset = footer, inactive, nohscroll, noKeepOnOnePage, preserveAspect, center, M7, L1,  12;
	fontset = Left Footer, cellOutline, blackBox,  12, "Palatino"; ;
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  10, "Times"; ;
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12, "Courier"; ;
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	next21StandardFontEncoding; ]
:[font = title; inactive; preserveAspect; startGroup; ]
Analyzing Data from Zenda
:[font = subsection; inactive; preserveAspect; startGroup; ]
Read in required packages
:[font = input; preserveAspect; endGroup; ]
<<Statistics`DescriptiveStatistics`
<</hal/Zenda/ZendaDistn/StatPlots.m
:[font = subsection; inactive; preserveAspect; startGroup; ]
Read in data
:[font = input; preserveAspect; endGroup; ]
{pay,choice,card} = ReadData["/hal/Zenda/Data/July16/Raw/zendaB.data.spaces",8];
:[font = subsection; inactive; preserveAspect; startGroup; ]
Set parameters
:[font = input; preserveAspect; endGroup; ]
round1=15;
round2=25;
:[font = subsection; inactive; preserveAspect; startGroup; ]
Execute this cell
:[font = input; preserveAspect; endGroup; endGroup; ]
   Print[StringForm["Phase 1 fraction of cooperation = ``",N[LocationReport[Take[Map[Mean,choice,1],round1]]]]]
   Print[StringForm["Phase 1 card played = ``",N[LocationReport[Take[Map[Mean,card  ,1],round1]]]]] 
   Print[StringForm["Phase 2 fraction of cooperation = ``",N[LocationReport[Take[Map[Mean,choice,1],-round2]]]]]
   Print[StringForm["Phase 2 card played = ``",N[LocationReport[Take[Map[Mean,card  ,1],-round2]]]]]
   Print[StringForm["Phase 2 card payment = ``",N[LocationReport[Take[Map[Mean,pay  ,1],-round2]]]]]
   Print["Quartile plots of fraction cooperating plays, card played, payment"]
   QuartilePlot[choice]
   QuartilePlot[card]
   QuartilePlot[pay]
   Print["Range plots of fraction cooperating plays, card played, payment"]
   RangePlot[choice]
   RangePlot[card]
   RangePlot[pay]


^*)